<?php

namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CRM\Service\IntegracaoMauticService;
use Teknisa\CRM\Service\crm00001000ParametrizacaoCrmService;

class IntegracaoMauticController {
    protected $mauticService;
    protected $crmParamService;
    
    public function __construct(IntegracaoMauticService $mauticService,
        crm00001000ParametrizacaoCrmService $crmParamService) {
            
        $this->mauticService   = $mauticService;
        $this->crmParamService = $crmParamService;
    }
    
    public function saveParamMautic(Row $request, Response $response) {
        header("Access-Control-Allow-Origin: *");
        header("Access-Control-Allow-Credentials: true");
        header("Access-Control-Allow-Methods: GET, HEAD, OPTIONS, POST, PUT");
        header("Access-Control-Allow-Headers: Content-Type");
        
        $row = $request->getRow();
        
        try {
            $this->mauticService->saveParamMautic($row);
            
            $returnArray = array(
                "AUTHENTICATED" => "success"
            );
            
            $response->addDataSet(new DataSet("DADOS", $returnArray));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}