<?php
namespace Teknisa\CRM\Factory;


use Doctrine\ORM\EntityManager;

class ProfileFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function getPasswordOperator($cdoperador){
        
        $select  = "SELECT CDSENHAOPERWEB 
                      FROM OPERADOR 
                        WHERE CDOPERADOR = :CDOPERADOR";
                       
        try{
            $std = $this->connection->prepare($select);
            $std->execute($cdoperador);
            $password = $std->fetchAll(); 
            
            return $password[0];
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function setNewPassword($paramsUpdate){
        
        $select  = "UPDATE OPERADOR
                      SET CDSENHAOPERWEB = :CDSENHAOPERWEB
                      WHERE CDOPERADOR = :CDOPERADOR
                        AND NRORG = :NRORG";
                       
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsUpdate);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public static function getMaxNrPerfAcessParc(){
      $select  = "SELECT MAX(NRPERFACESSPARC) as MAXNRPERFACESSPARC FROM PERFACESSPARC";
                       
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $maxCode = $std->fetchAll(); 
            
            if(!empty($maxCode))
              return (int)$maxCode[0]['MAXNRPERFACESSPARC'] + 1;
            else
              return 1;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    

}
?>