<?php
namespace Teknisa\CRM\Service;

class crm20000CasoAnexosService
{
    
    protected $anexosCasoFactory;
    
    public function __construct ($anexosCasoFactory){
        
        $this->anexosCasoFactory   = $anexosCasoFactory;
    }
    
    public function callForDeleteFilesByOriginNumber($row){
        
        $paramsDeleteFiles = array(
            
            "NRORIGEM"      => $row["NRORIGEM"]
            
        );
        
        $this->anexosCasoFactory->requestForDeleteFilesByOriginNumber($paramsDeleteFiles);
            
    }
    
    public function callForGetFilesUrlByOriginNumber($row){
        
        $paramsSelectUrls = array(
            
            "NRORIGEM"      => $row["NRORIGEM"]
            
        );
        
        $fileUrls = $this->anexosCasoFactory->requestForGetFilesUrlByOriginNumber($paramsSelectUrls);

        return $fileUrls;
    }
    
    public function callForUpdateIdAnnex($row, $hasAnnex){
        
        $paramsUpdateIdAnnex = array(
            
            "NRSEQEVOLCONT"     => $row["NRORIGEM"],
            "IDANEXOEVOLCONT"   => $hasAnnex
            
        );
        
        $this->anexosCasoFactory->requestForUpdateIdAnnex($paramsUpdateIdAnnex);
    }
    
    public function callForCheckIfHasAnnex($row){
        
        $paramsCheckIfHasAnnex = array(
        
            "NRORIGEM"  => $row["NRORIGEM"]
            
        );
        
        $hasAnnex = $this->anexosCasoFactory->requestForCheckIfHasAnnex($paramsCheckIfHasAnnex);
        
        return $hasAnnex;
    }
}