function PartnerInfosModalController(CRM_Utilities, ScreenService, templateManager, metaDataFactory){
    
    CRM_Utilities.addController(this, 'PartnerInfosModalController');
    
    /**
     * Builda o modal.
     * 
     * @param {object} widget widget que irá receber o modal.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget modal construida.
     * 
    */
    this.factoryModalWidget = function(activeWidget, nrparcnegocio) {
        
        /*Modificado em 22/09 por Arthur
            Adicionada propriedade 'preventHide',
            que garante que a widget Dados do Parceiro 
            não tenha suas actions setadas como invisíveis em chamados já 
            concluidos
        */
        var modalWidgetJson = {
            "id":"17223197583113",
            "name": "WDGT_MODAL_PARTNER_INFOS",
            "label": "Informações do Parceiro",
            "container": activeWidget.container,
            "parent": activeWidget,
            "template": "widget/tabbedWidget.html",
            "defaultTab": "WDGT_PARTNER_DATA",
            "showAsModal": true,
            "preventHide":true,
            "showAsTab":false,
            "isVisible": true,
            "events":[
                {
                    "id":"17223197583113124",
                    "name":"WidgetOnEnterOnce",
                    "code":"AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(args.owner);ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(args.owner, 5);PartnerInfosModalController.changeTemplateTabInterlocutor(args.owner);"
                }
            ],
            "widgets":[
                {
                    "id":"17223197583113123",
                    "name": "WDGT_PARTNER_DATA",
                    "label": "Dados",
                    "container": activeWidget.container,
                    "template": "widget/form-view.html",
                    "isVisible": true,
                    "dataSource": {
                        "name": "product#/crm_candidato_prospect_parcnegocio",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "CRM_NRORGTRAB",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRABALHO')@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113125",
                            "name": "WidgetOnEnter",
                            "code": "PartnerInfosModalController.setModalFilterByActivePartner(args.owner.parent, templateManager.container.getWidget('" + activeWidget.name + "'), '" + nrparcnegocio + "');"
                        },
                        {
                            "id":"17223197583113126",
                            "name": "WidgetAfterLoadDataSource",
                            "code": "args.owner.moveToFirst();"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113127",
                            "name": "NOMEPRINCIPAL",
                            "label": "Nome",
                            "template": "field/text-edit.html",
                            "class": "12",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113128",
                            "name": "NOMEFANTASIA",
                            "label": "Nome Fantasia",
                            "template": "field/text-edit.html",
                            "class": "12",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113129",
                            "name": "INSCRICAO",
                            "label": "Inscrição",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113130",
                            "name": "TIPOINSCRICAO",
                            "label": "Tipo Inscrição",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "validations": {},
                            "events": [],
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Física",
                                        "value": "CPF"
                                    },
                                    {
                                        "name": "Jurídica",
                                        "value": "CNPJ"
                                    },
                                    {
                                        "name": "Outros",
                                        "value": "CODIGO"
                                    },
                                    {
                                        "name": "Inscrição",
                                        "value": "LIVRE"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113131",
                            "name": "NMOPERRESPONSAVEL",
                            "label": "Operador Responsável",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113132",
                            "name": "TIPOPARCEIRO",
                            "label": "Tipo Parceiro",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Lead",
                                        "value": "CANDIDATO"
                                    },
                                    {
                                        "name": "Prospect",
                                        "value": "PROSPECT"
                                    },
                                    {
                                        "name": "Cliente",
                                        "value": "CLIENTE"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113133",
                            "name": "DSSEGMER",
                            "label": "Segmento de Mercado",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113134",
                            "name": "DSATIVCLI",
                            "label": "Ramo de Atividade",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113135",
                            "name": "DSTPATIVCLIENTE",
                            "label": "Tipo de Atividade",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113136",
                            "name": "NMMODODIVULG",
                            "label": "Como Chegou Até Nós",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113137",
                            "name": "IDATIVO",
                            "label": "Ativo",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "validations": {},
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Sim",
                                        "value": "S"
                                    },
                                    {
                                        "name": "Não",
                                        "value": "N"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113138",
                            "name": "NRFUNCIONARIOS",
                            "label": "Nr. Funcionários",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        }
                    ],
                    "widgets":[]
                },
                {
                    "id": "14418982341257778598851",
                    "name": "WDGT_DADOS_ADICIONAIS",
                    "container": activeWidget.container,
                    "label": "Dados Adicionais",
                    "showCheckbox": false,
                    "isVisible": true,
                    "itemsPerPage": 30,
                    "template": "widget/form-view.html",
                    "templateToForm":"widget/form.html",
                    "showDescriptionOrder": false,
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "product#/crud/ger_parcnegocioinfo",
                        "itemsPerPage": 100
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id": "14418982343495474723876",
                            "name": "WidgetOnEnter",
                            "code": "PartnerInfosModalController.setCurrentRowDadosAdicionais(args.owner)"
                        }
                    ],
                    "fields": [   
                        {
                            "id":"17223197583113139",
                            "name": "NMRESPGERAL",
                            "label": "Responsável Geral",
                            "class":"12",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113140",
                            "name": "NMPONTOATENDIMENTO",
                            "label": "Ponto de Atendimento",
                            "class":"12",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113141",
                            "name": "NRPONTUACAO",
                            "label": "Pontuação",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113142",
                            "name": "CDINTEGRACAO",
                            "label": "Núm. Integração",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113143",
                            "name": "DTINIRELACIONA",
                            "label": "Data de Início do Relacionamento",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "dateFormat": "DD/MM/YYYY",
                            "template": "field/calendar.html"
                        },
                        {
                            "id":"17223197583113143",
                            "name": "NMMODORECEBINFO",
                            "label": "Como Deseja Receber Informações",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": []
                },
                {
                    "id":"17223197583113144",
                    "name": "WDGT_PARTNER_ADDRESS",
                    "label": "Endereços",
                    "container": activeWidget.container,
                    "template": "widget/grid.html",
                    "isVisible": true,
                    "dataSource": {
                        "name": "product#/crud/enderecoparc_localizacao_tipoendereco",
                        "rest": true,
                        "itemsPerPage": 50,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113144",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113145",
                            "label": "Tipo de Endereço",
                            "name": "NMTIPOENDERECO",
                            "template": "field/text-edit.html",
                            "isVisible": true,
                            "showOnForm": true,
                            "showOnList": true,
                            "valueField": "CDTIPOENDERECO",
                            "descriptionField": "NMTIPOENDERECO",
                            "dataSource": {},
                            "events": []
                        },
                        {
                            "id":"17223197583113146",
                            "name": "NRCEPENDERECO",
                            "label": "CEP",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "events": [],
                            "mask": {
                                "type": "fix",
                                "params": {
                                    "cleanMaskOnModel": true,
                                    "mask": "99999-999"
                                }
                            }
                        },
                        {
                            "id":"17223197583113147",
                            "name": "DSENDERECO",
                            "label": "Endereço",
                            "validations": {
                                "required": true
                            },
                            "maxlength": 250,
                            "class": "10",
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113147",
                            "name": "NRIMOVELENDERECO",
                            "label": "Número",
                            "class": "2",
                            "maxlength": 10,
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113148",
                            "name": "DSCOMPLEENDERECO",
                            "label": "Complemento",
                            "class": "12",
                            "maxlength": 100,
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113149",
                            "name": "NMPAIS",
                            "label": "País",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/pais",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDPAIS": "CDPAIS",
                                "NMPAIS": "NMPAIS"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113150",
                                    "label": "Código",
                                    "name": "CDPAIS",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113151",
                                    "label": "País",
                                    "name": "NMPAIS",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113152",
                            "name": "NMESTADO",
                            "label": "Estado",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/estado",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "SGESTADO": "SGESTADO",
                                "NMESTADO": "NMESTADO"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113153",
                                    "label": "Sigla",
                                    "name": "SGESTADO",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113153",
                                    "label": "Estado",
                                    "name": "NMESTADO",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113154",
                            "name": "NMMUNICIPIO",
                            "label": "Município",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/municipio",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDMUNICIPIO": "CDMUNICIPIO",
                                "NMMUNICIPIO": "NMMUNICIPIO"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113155",
                                    "label": "Código",
                                    "name": "CDMUNICIPIO",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113156",
                                    "label": "Município",
                                    "name": "NMMUNICIPIO",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113157",
                            "name": "NMBAIRRO",
                            "label": "Bairro",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/bairro",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDBAIRRO": "CDBAIRRO",
                                "NMBAIRRO": "NMBAIRRO"
                            },
                            "events": []
                        }
                    ],
                    "widgets": []
                },
                {
                    "id":"17223197583113158",
                    "name": "WDGT_PARTNER_CONTACTS",
                    "label": "Contatos",
                    "container": activeWidget.container,
                    "template": "widget/grid.html",
                    "isVisible": false,
                    "dataSource": {
                        "rest": true,
                        "name": "product#/crm_relacionaparc",
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORG')@"
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORG')@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113159",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113160",
                            "name": "NOMECONT",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "validations": {
                                "required": true
                            },
                            "class": 10,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113161",
                            "name": "EMAIL",
                            "label": "Email",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "showOnForm": true,
                            "class": 6,
                            "template": "field/text-edit.html",
                            "events": []
                        },
                        {
                            "id":"17223197583113162",
                            "name": "TELEFONE",
                            "label": "Telefone",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "showOnForm": true,
                            "class": 6,
                            "template": "field/text-edit.html",
                            "events": []
                        },
                        {
                            "id":"17223197583113163",
                            "name": "NMTIPOPARCEIRO",
                            "label": "Tipo de Parceiro",
                            "template": "field/select.html",
                            "isVisible": true,
                            "showOnList": true,
                            "class": "12",
                            "valueField": "TIPODEPARCEIRO",
                            "descriptionField": "NMTIPODEPARCEIRO",
                            "dataSource": {
                                "rest": true,
                                "name": "product#/crm_tipoParceiro",
                                "lazyLoad": true
                            },
                            "outData": {
                                "NMTIPODEPARCEIRO": "NMTIPODEPARCEIRO",
                                "TIPODEPARCEIRO": "TIPODEPARCEIRO"
                            },
                            "dataSourceFilter": [],
                            "events": []
                        }
                    ],
                    "widgets": []
                },
                {
                    "id": "14418982341257778598852",
                    "name": "WDGT_PARTNER_COMU",
                    "container": activeWidget.container,
                    "label": "Comunicação",
                    "showCheckbox": false,
                    "isVisible": true,
                    "itemsPerPage": 30,
                    "template": "widget/master_detail/grid.html",
                    "showDescriptionOrder": false,
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "product#/crm_comunicaparc",
                        "itemsPerPage": 100
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id": "14418982343495474723875",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id": "14418982341628670838852",
                            "name": "IDATIVO",
                            "label": "Ativo",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982342800647217853",
                            "name": "NRCOMUNICAPARC",
                            "label": "NRCOMUNICAPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "showOnForm": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982341061414688854",
                            "name": "NRPARCNEGOCIO",
                            "label": "NRPARCNEGOCIO",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982344140770823855",
                            "name": "NRENDERECOPARC",
                            "label": "NRENDERECOPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "showOnForm": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1441898234664443810856",
                            "name": "CDCOMPLECOMUPARC",
                            "label": "CDCOMPLECOMUPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982341567386213857",
                            "name": "CDFORMACOMU",
                            "label": "Forma de Comunicação",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1441898234614649406858",
                            "name": "NMFORMACOMU",
                            "label": "Forma de Comunicação",
                            "class": "12",
                            "order": "CDFORMACOMU",
                            "maxlength": 4,
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "readOnly": false,
                            "defaultValue": null,
                            "template": "field/select.html",
                            "showSelectAs": "grid",
                            "validations": {
                                "required": true
                            },
                            "newLine": true,
                            "placeholder": null,
                            "dataSource": {
                                "rest": true,
                                "localStorage": true,
                                "name": "product#/formacomu",
                                "itemsPerPage": 50,
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [
                                {
                                    "name": "NRORG",
                                    "operator": "IN",
                                    "value": "@[getLocalVar('CRM_NRORGTRAB'),getLocalVar('CRM_NRORGPADRAO') ]@"
                                }
                            ],
                            "outData": {
                                "CDFORMACOMU": "CDFORMACOMU",
                                "NMFORMACOMU": "NMFORMACOMU"
                            },
                            "fields": [
                                {
                                    "id": "14418982344259089695859",
                                    "label": "Código",
                                    "name": "CDFORMACOMU",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id": "14418982341859185194860",
                                    "label": "Forma de Comunicação",
                                    "name": "NMFORMACOMU",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id": "14418982341691438344861",
                            "name": "CDPREFIXCOMUPARC",
                            "label": "Prefixo",
                            "class": "2",
                            "isVisible": true,
                            "showOnList": true,
                            "maxlength": 10,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982342324818248862",
                            "name": "CDCOMUNICAPARC",
                            "label": "Descrição",
                            "class": "10",
                            "isVisible": true,
                            "showOnList": true,
                            "validations": {
                                "required": true
                            },
                            "maxlength": 250,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": []
                }
			],
			"actions": [
			    {
			        "id":"17223197583113164",
                    "name": "BACK_MODAL",
                    "label": "Voltar",
                    "icon": "back",
                    "isVisible": true,
                    "showAsAction": "back",
                    "events": [
                        {
                            "id":"17223197583113165",
                           	"name": "ActionEvent",
                            "code": "ScreenService.closePopup(true)"
                        }
                    ]
                }
            ]
        };
        
        var modalWidget = metaDataFactory.widgetFactory(modalWidgetJson);
        
        return modalWidget;
        
    };
    
    /**
     * Abri o modal com as informações do parceiro.
    */
    this.openModal = function(){
        
        ScreenService.openPopup(templateManager.container.getWidget('WDGT_MODAL_PARTNER_INFOS')).then(function(){
            var widget = templateManager.container.getWidget('WDGT_PARTNER_DATA');
            //this.setDataWidgetCurrentRow(widget);
        }.bind(this));
        
    };
    
    /**
     * Define o filtro das widgets do modal informativo
     * de acordo com o parceiro selectionado na widget
     * ativa.
     * 
     * @param {object} modalWidget widget do modal informativo.
     * 
     * @param {object} activeWidget widget ativa onde o parceiro
     * foi selecionado.
     * 
     * @param {string} partnerFieldName nome do campo referente ao
     * parceiro de negócio.
    */
    this.setModalFilterByActivePartner = function(modalWidget, activeWidget, partnerFieldName){
        
        var selectedPartner = activeWidget.currentRow[partnerFieldName];
        
        var modalWidgets = modalWidget.widgets;
        var dataWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_DATA");
        var addressWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_ADDRESS");     
        var contactsWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_CONTACTS");
        var comunicationWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_COMU");
        var additionalWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_DADOS_ADICIONAIS");
        var dataWidget = modalWidgets[dataWidgetIndex]; 
        var addressWidget = modalWidgets[addressWidgetIndex];     
        var contactsWidget = modalWidgets[contactsWidgetIndex];
        var comunicationWidget = modalWidgets[comunicationWidgetIndex];
        var additionalWidget = modalWidgets[additionalWidgetIndex];
        
        var dataWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(dataWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var addressWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(addressWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var contactsWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(contactsWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var comunicationWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(comunicationWidget.dataSourceFilter, "P_NRPARCNEGOCIO");
        var additionalWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(additionalWidget.dataSourceFilter, "P_NRPARCNEGOCIO");
        
        dataWidget.dataSourceFilter[dataWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        addressWidget.dataSourceFilter[addressWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        contactsWidget.dataSourceFilter[contactsWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        comunicationWidget.dataSourceFilter[comunicationWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        additionalWidget.dataSourceFilter[additionalWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        
        dataWidget.reload();
        
    };
    
    /**
     * Atribui o parceiro retornado no data source do modal
     * na currentRow da widget de informações do parceiro
     * ('WDGT_PARTNER_DATA').
     * 
     * @param {object} widget widget de dados do parceiro.
     * ('WDGT_PARTNER_DATA').
    */
    this.setDataWidgetCurrentRow = function(widget){

        widget.moveToFirst();
        
    };
    
    /**
     * Insere a widget modal na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá o modal.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setModalWidgetOnActiveWidget = function(widget, nrparcnegocio){
        
        this.createModalAction(widget);
        widget.widgets.push(this.factoryModalWidget(widget, nrparcnegocio));
        
    };
    
    /**
     * Cria a action para abrir o modal com os dados
     *  do parceiro na widget.
     * 
     * @param {object} widget widget que receberá o modal.
     * 
    */
    this.createModalAction = function(widget){
        /*Modificado em 22/09 por Arthur
            Adicionada propriedade 'preventHide',
            que garante que a action de Dados do Parceiro 
            não seja setada como invisível em chamados já 
            concluidos
        */
        var modalAction = {
            "id":"17223197583113166",
            "name": "ACTION_MODAL_INFOS_PARCEIRO",
            "label": "Consultar Dados do Parceiro",
            "isVisible": true,
            "preventHide":true,
            "showAsAction": "never_view",
            "events": [
                {
                    "name": "ActionEvent",
                    "code": "PartnerInfosModalController.openModal();"
                }
            ]
        };
        
        if((widget.template.search("master_detail") === -1) && widget.template.search("kanban") === -1){
            modalAction.showAsAction = "never_list";
        }
        
        //metaDataFactory.actionFactory(modalAction, widget, true);
        
        if(!widget.getAction('ACTION_MODAL_INFOS_PARCEIRO')) {
            widget.actions.push(modalAction);
        }
        
    };
    
    
    /**
     * Muda o template da tab de interlocutor, necessário
     * para evitar o click na row, que abria o swipe.
     * 
     * @param {object} widget widget modal.
     * 
    */
    this.changeTemplateTabInterlocutor = function(widget){
        var interlocutorTab = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        interlocutorTab.template = 'widget/grid.html';
        templateManager.updateTemplate();
        interlocutorTab.activate();
    };
    
    this.setCurrentRowDadosAdicionais = function(widget){
        widget.reload().then(function(){
            if(!Util.isEmptyOrBlank(widget.dataSource.data))
                widget.currentRow = widget.dataSource.data[0];
        });
    }
    
    /**
     * Evita Bug de tamanho de colunas inferior ao tamanho do registro
    */
    this.resizeWindow = function(){
        $(window).resize();
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('PartnerInfosModalController', PartnerInfosModalController);
});